*
* VSAVE - ERT VSAVE("filename"\ | , var1 [,var2 ..])
* where var is either an array or scalar variable
*
        section code

        xdef VSAVE

        xref    sentinel
        xref    check_pars,get_open,close,soft_err,hard_err
        xref    print,printb,save,save_r
        xref    get_pat            ;win1_asm_sbu_par_Getpat -> library
        xref    resrir             ;win1_asm_sbu_uti_resrir -> library
*
VSAVE
        bsr     sentinel        ;d4 = empty stack pointer
        bsr     check_pars      ;d2=overwrite flag, d7=num pars
*
        moveq   #3,d3           ;ready to open OVER
        cmpi.b  #$30,d2         ;d2 = separator info
        beq.s   vs_open         ;backlash means open over
        moveq   #2,d3           ;other means new file
vs_open
        bsr     get_open        ;open, don't return if parameter error
        bne     soft_err        ;file errors are soft
*
        move.l  #'VS01',d0      ;header flag + version number
        move.w  d7,d2           ;number of parameters (excl filename)
        bsr     printb          ;print 6 bytes from buffer (on error quit)
        bra.s   ml_end          ;if no more pars then quit
main_loop
        move.l  d4,$58(a6)      ;reset stack to avoid accumulating memory
        bsr     get_pat         ;get parameter according to type
        bmi     hard_err        ;bad parameters get the hard treatment
        movea.l a1,a4           ;save stack pointer
        bsr.s   prt_pat         ;print header and variable to file
ml_end
        dbra    d7,main_loop
*
        moveq   #4,d2           ;print terminator (long 0)
        movea.l (a6),a1
        clr.l   0(a6,a1.l)
        bsr     print
*
        moveq   #0,d0
        bra     soft_err
*
prt_pat
        move.w  d5,d2           ;unified type spec, eg $0203 or $0301
        move.l  d6,d0           ;array?
        bne.s   prt_arr
prt_v
        move.l  d1,d0           ;d0 will be skip length
        bsr.s   prt_buf         ;print out skip length & type from buffer
        move.l  d1,d2           ;length of variable to print
        movea.l a4,a1
        bra     print           ;print it to file and loop
prt_arr
        lsl.l   #2,d0           ;descriptor len = nodims * 4
        addq.l  #2,d0           ;plus number of dimns counter itself
        move.l  d0,d6           ;d6 = number of bytes to print
        add.l   d1,d0           ;d0 = skip length
prt_a
        bsr.s   prt_buf         ;print out skip length and type information
        lea.l   4(a2),a1        ;point to descriptor
        move.l  d6,d2           ;no. bytes to print
        bsr     print           ;now go do it
        movea.l a4,a1           ;a1 -> array data
        move.l  d1,d2           ;this many data bytes to print
        bra     save_r          ;save it and loop
prt_buf
        addq.l  #6,d0           ;skip length is type(+descr)+data+skip itself
        bra     printb          ;print it and return (if no error)
*
        end
